#ifndef	_WRAPCAPS_HXX
#define	_WRAPCAPS_HXX

#include <ptlib.h>
#include "h323caps.h"

#define	WRAP_G726_40	"G.726-40k"
#define	WRAP_G726_32	"G.726-32k"
#define	WRAP_G726_24	"G.726-24k"
#define	WRAP_G726_16	"G.726-16k"

/* Speed index (see Wrap_G726_Info) */
#define	WRAP_G726_SPEED40	0
#define	WRAP_G726_SPEED32	1
#define	WRAP_G726_SPEED24	2
#define	WRAP_G726_SPEED16	3

extern OpalMediaFormat const WrapG726_40;
extern OpalMediaFormat const WrapG726_32;
extern OpalMediaFormat const WrapG726_24;
extern OpalMediaFormat const WrapG726_16;

class Wrap_G726_Capability : public H323NonStandardAudioCapability
{
	PCLASSINFO(Wrap_G726_Capability, H323NonStandardAudioCapability);
public:
	Wrap_G726_Capability(H323EndPoint &ep, int sp);
	PObject *Clone() const;
	BOOL IsValid() const;
	PString GetFormatName() const;
	BOOL OnSendingPDU(H245_AudioCapability &pdu, unsigned packetSize) const;
	BOOL OnReceivedPDU(const H245_AudioCapability &pdu, unsigned &packetSize);
	H323Codec *CreateCodec(H323Codec::Direction direction) const;
protected:
	int speed;
};

class Wrap_G726_Codec : public H323AudioCodec
{
	PCLASSINFO(Wrap_G726_Codec, H323AudioCodec);
public:
	Wrap_G726_Codec(int sp, Direction dir, unsigned frameSize);
	unsigned GetSpeed();
	BOOL Read(BYTE *buffer, unsigned &length, RTP_DataFrame &);
	BOOL Write(const BYTE *buffer, unsigned length, 
					const RTP_DataFrame & /*frame*/,
					unsigned & written);
	BOOL IsRawDataChannelNative() const;
protected:
	unsigned packetSize;
	unsigned speed;
};

#endif /* _WRAPCAPS_HXX */
